package com.maroontress.madangler.client;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.Response;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Element;
import com.maroontress.madangler.client.request.Parameters;
import com.maroontress.madangler.client.request.RequestKit;
import com.maroontress.madangler.client.request.RequestListener;

/**
   ץȤIDɽѥͥǤ

   ץȸͭΥ֥ѥͥǤϡ֥ѥͥκǽɲä륦
   åȤˤʤޤ
*/
public class ProjectTitlePanel extends HorizontalPanel {

    /** IDδ֤Υå */
    private HTML htmlDash;

    /** ץȤ */
    private HTML htmlDesc;

    /** ץID */
    private HTML htmlId;

    /** ꥯȥå */
    private RequestKit kit;

    /** ꥯȥꥹ */
    private RequestListener loadedListener;

    /**
       ץȥȥѥͥޤ
    */
    public ProjectTitlePanel() {
	htmlId = new HTML();
	htmlDash = new HTML("&nbsp;&#x2015;&nbsp;");
	htmlDesc = new HTML();
	add(htmlId);
	add(htmlDash);
	add(htmlDesc);

	kit = new RequestKit();
        loadedListener = new RequestListener() {
	    public void startRequest() {
	    }
	    public void stopRequest() {
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		if (parseGetPropertyResponse(res.getText()) < 0) {
		    return;
		}
		htmlDesc.setVisible(true);
		htmlDash.setVisible(true);
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
	    }
	};
    }

    /**
       ץIDꤷޤ

       @param id ץID
    */
    public void setProjectId(final String id) {
	kit.cancel();
	htmlId.setText(id);
	htmlDash.setVisible(false);
	htmlDesc.setVisible(false);

	Parameters params = new Parameters();
	params.add("method", "getProperty");
	params.add("projectId", id);
	kit.sendRequest(params.toString(), loadedListener);
    }

    /**
       getProperty쥹ݥ󥹤ѡƥץȤꤷޤ

       @param text getProperty쥹ݥ
       @return 0Ǥʤ-1
    */
    private int parseGetPropertyResponse(final String text) {
	Status status;
        try {
	    status = new Status(text);
        } catch (DOMException e) {
            return -1;
        }
	if (status.getCode() != 0) {
            return -1;
	}
	Element prop = status.getFirstChildNode("property");
	if (prop == null) {
            return -1;
	}
	String desc = prop.getAttribute("description");
	if (desc == null || desc.equals("")) {
            return -1;
	}
	htmlDesc.setText(desc);
	return 0;
    }
}
