#ifndef Platform_H
#define Platform_H

struct com_maroontress_libcgi_db_Box;
struct com_maroontress_libcgi_db_BoxKit;

struct Platform {
    char *id;
    char *host;
    char *command;
    char *charset;
};

int Platform_getStringWithBox(
    struct com_maroontress_libcgi_db_Box *box,
    int k, const char *name, char **value);
int Platform_getIntWithBox(
    struct com_maroontress_libcgi_db_Box *box,
    int k, const char *name, int *value);

int Platform_setStringWithBoxKit(
    struct com_maroontress_libcgi_db_BoxKit *kit,
    int k, const char *name, const char *value);
int Platform_setIntWithBoxKit(
    struct com_maroontress_libcgi_db_BoxKit *kit,
    int k, const char *name, int value);

struct Platform * Platform_createWithBoxKit(
    struct com_maroontress_libcgi_db_BoxKit *kit, unsigned int k);
void Platform_free(struct Platform *platform);

#endif
